* EXTREMA.F computes pt5min,pt6min,shatmin using the cuts selected by the user
* and stores them in the common/min_extrema/
*  
      SUBROUTINE extrema

      IMPLICIT REAL*8 (a-b,d-h,o-z)
      IMPLICIT COMPLEX*16 (c)

      include 'common.h'
      include 'common_cut.h'
      include 'common_subproc.h'
      COMMON/fxn_extrema/pt5min,pt6min,shatmin

*      LOCAL VARIABLES
      DIMENSION idpout(6),idpin(2)
         
* EXTRACT FINAL AND INITIAL STATE PARTICLES
* COUNT FINAL STATE JETS, MUONS, ELECTRONS, NEUTRINOS
* COMPUTE SUM OF FINAL AND INITIAL STATE MASSES
      njets=0
      nleptons=0
      nneutrinos=0
      totalmassout=0.d0
      totalmassin=0.d0
      iout=1
      iin=1
      DO i=1,8
        IF(idp_inout(i).GT.0)THEN
          idpout(iout)=idp(i)
          IF(abs(idpout(iout)).LE.5) njets=njets+1
          IF((abs(idpout(iout)).EQ.11).OR.(abs(idpout(iout)).EQ.13)
     &        .OR.(abs(idpout(iout)).EQ.15)) nleptons=nleptons+1
          IF(abs(idpout(iout)).EQ.12 .OR.
     &       abs(idpout(iout)).EQ.14) nneutrinos=nneutrinos+1
          totalmassout=totalmassout+rmass(idpout(iout))
          iout=iout+1
        ELSE
          idpin(iin)=idp(i)
          totalmassin=totalmassin+rmass(idpin(iin))
          iin=iin+1
        ENDIF
      ENDDO
      IF(iout.NE.7  .OR. iin.NE.3)THEN
        WRITE(*,*) "WRONG INITIAL/FINAL STATE"
        STOP
      ENDIF 

C   PDG        parton label (6, 5, 4, 3, 2, 1, 0, -1, ......,-5,-6)
C                       for (t, b, c, s, u, d, g, d~, ....., b~,t~)
C   PDG        parton label (11, 12,  13,  14,  15,   16)
C                       for (e-, ve, mu-, vmu, tau, vtau)
      shatmin=0.d0

* MINIMUM MASS SEPARATION BETWEEN JETS
      IF(i_rm_min_jj.EQ.1) THEN
        shatmin=shatmin+njets*(njets-1.d0)/2.d0*rm_min_jj*rm_min_jj
* SUBTRACT EXTRA MASSES: s= SUM(i>j)(2*p_i*p_j)+SUM(i)(m^2_i)
*                        m_ij=2*p_i*p_j+m^2_i+m^2_j
*                        each momentum appears in (njet-1) m_ij
        DO i=1,6
          IF(abs(idpout(i)).LE.5)THEN
            shatmin=shatmin-(njets-2)*rmass2(idpout(i))
          ENDIF
        ENDDO
*      MINIMUM MASS SEPARATION BETWEEN CENTRAL JETS IF rm_min_jcjc > rm_min_jj
        IF(i_rm_min_jcjc.EQ.1) THEN
          IF(rm_min_jcjc.GT.rm_min_jj)THEN
             shatmin=shatmin+
     &        (njets-2.d0)*(njets-3.d0)/2.d0*(rm_min_jcjc*rm_min_jcjc
     &                                   -rm_min_jj*rm_min_jj)
          ENDIF
        ENDIF
*      MINIMUM INVARIANT MASS OF FORWARD AND BACKWARD JETS
        IF(i_rm_min_jfjb.EQ.1) THEN
          IF(rm_min_jfjb.GT.rm_min_jj)THEN
             shatmin=shatmin+rm_min_jfjb*rm_min_jfjb
     &                                  -rm_min_jj*rm_min_jj
          ENDIF
        ENDIF
      ENDIF

* ASK FOR MINIMUM MASS SEPARATION BETWEEN CHARGED LEPTONS AND JETS
* ASSUME ONLY ONE IS PRESENT
      IF(i_rm_min_jlep.EQ.1) THEN
        IF(nleptons.GT.0)THEN
          shatmin=shatmin+njets*rm_min_jlep*rm_min_jlep
        ENDIF
* SUBTRACT EXTRA MASSES IF NECESSARY: Muons considered massless
        IF(i_rm_min_jj.EQ.1)THEN
          DO i=1,6
            IF(abs(idpout(i)).LE.5)THEN
              shatmin=shatmin-rmass2(idpout(i))
            ENDIF
          ENDDO
        ENDIF
      ENDIF

* ADDITIONAL CONSTRAINTS ON shatmin
      emin=nleptons*pt_min_lep+min(nneutrinos,1)*ptmiss_min
      DO i=1,6
        IF(abs(idpout(i)).LE.5)THEN
          emin=emin+sqrt(rmass2(idpout(i))+pt_min_j*pt_min_j)
        ENDIF
      ENDDO
      shatmin=max(shatmin,totalmassout*totalmassout,
     &                 totalmassin*totalmassin,emin*emin)
      
      pt5min=max(pt_min_lep,ptmiss_min,pt_min_j)
      IF(pt_min_lep.GT.0.d0) pt5min=min(pt5min,pt_min_lep)
      IF(ptmiss_min.GT.0.d0) pt5min=min(pt5min,ptmiss_min)
      IF(pt_min_j.GT.0.d0) pt5min=min(pt5min,pt_min_j)
      pt6min=pt5min

      RETURN
      END

      
