***********************************************************************
*     STANDARD VEGAS INPUT:
*     PARAMETERS
*     mxnphs          : total number of possible phase space mappings
*     THROGH COMMON BLOCKS:
*     iphs_ind    : phase space to be used for generating momenta
*     ialfa(mxnphs)  : 0/1 inactive/active phase space
*     alfa(mxnphs)   : phase space weight in multichannel
*     idp(8)       : particle identities: ASSUMED OUTGOING
*     idp_inout(8) : idp_inout(i)=1(-1) for outgoing(incoming) particles
*     iorder(8,mxnphs)
*     
*     MISSING:
*     QED coupling to be passed in the LESHOUCHES common ?
*     QCD coupling to be passed in the LESHOUCHES common: 
*     same as used in PDF? At present the two Les Houches flags aqedup 
*     and aqcdup are set to -1
***********************************************************************

      REAL*8 FUNCTION fxn(x,wgt)

      IMPLICIT REAL*8 (a-b,d-h,o-z)
      IMPLICIT DOUBLE COMPLEX (c)

*************************OVERALL COMMONS *****************************
      
      INCLUDE 'common.h'
      INCLUDE 'common_cut.h'
      INCLUDE 'common_subproc.h'
      COMMON/fxn_extrema/pt5min,pt6min,shatmin
*sandro 27/7
c      COMMON/fxn_main/s,flux,factor
      COMMON/fxn_main/flux,factor
*sandro 27/7 end
*     INTEGRATION COMMONS
      COMMON/iinteg_readinput/ncall_therm,itmx_therm,ncall,itmx
      COMMON/rinteg_readinput/acc_therm,acc

      COMMON/phspinput_proc/
     &  rm1(mxnphs),gam1(mxnphs),spm1lo(mxnphs),spm1hi(mxnphs),
     &  rm11a(mxnphs),gam11a(mxnphs),spm11alo(mxnphs),spm11ahi(mxnphs),
     &  rm11b(mxnphs),gam11b(mxnphs),spm11blo(mxnphs),spm11bhi(mxnphs),
     &  rm12a(mxnphs),gam12a(mxnphs),spm12alo(mxnphs),spm12ahi(mxnphs),
     &  rm12b(mxnphs),gam12b(mxnphs),spm12blo(mxnphs),spm12bhi(mxnphs),
     &  rm2(mxnphs),gam2(mxnphs),spm2lo(mxnphs),spm2hi(mxnphs),
     &  rm2a(mxnphs),gam2a(mxnphs),spm2alo(mxnphs),spm2ahi(mxnphs),
     &  rm2b(mxnphs),gam2b(mxnphs),spm2blo(mxnphs),spm2bhi(mxnphs),
     &  rm21a(mxnphs),gam21a(mxnphs),spm21alo(mxnphs),spm21ahi(mxnphs),
     &  rm21b(mxnphs),gam21b(mxnphs),spm21blo(mxnphs),spm21bhi(mxnphs),
     &  rm111(mxnphs),gam111(mxnphs),spm111lo(mxnphs),spm111hi(mxnphs),
     &  rm11(mxnphs),gam11(mxnphs),spm11lo(mxnphs),spm11hi(mxnphs),
     &  rmta(mxnphs),expa(mxnphs),spta,rmtb(mxnphs),expb(mxnphs),sptb

      COMMON /pharand/ idum

***********************VEGAS *****************************************
      DIMENSION x(15)
*6
c      COMMON/abresl/resl(10),standdevl(10)
*6end
      COMMON/abstat/ncall_eff
******************CONTROL FLAGS***************************************
      COMMON/i_norm/i_normalize
      COMMON/phaones/ionesh
*************************EXTERNAL PARTICLES **************************
      DIMENSION  xm(8),xmsq(8)
*************************DISTRIBUTION FUNCTIONS **********************
      REAL*8 Ctq5Pdf,Q
      EXTERNAL Ctq5Pdf
      DIMENSION distfun(4)
********LESHOUCHES USER PROCESS EVENT COMMON BLOCK *******************
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      REAL*8 XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &   ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &   VTIMUP(MAXNUP),SPINUP(MAXNUP) 
*6
c******************************PYTHIA *********************************
c      PARAMETER(NMXHEP=4000)
c      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
c     &   JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*6end
***********************Hadronization output **************************
      INTEGER IPRDEB
      COMMON/HADOUTPUT/IPRDEB
*******************PHASE SPACE and MULTICHANNEL **********************
      DIMENSION p(0:3,8),pcoll(0:3,8)
*************************PERMUTATIONS ********************************
      INTEGER idin0(2),ipos0(3,-16:16),index(3,6),ifact(0:3),
     &     nidentical(-16:16),idin0_cteq(2),
     &  iordaux(8),iorderaux(8),iordtemp(3),nmultiple,
     &     i_multzero,i_identical(3),index_pythia(8),iordamp(8),
     &     idp0(8),idp0_inout(8)
      REAL*8 paux(0:3,8),symfact
      DATA index/1,2,3,         !even
     &     2,1,3,
     &     2,3,1,               !even
     &     1,3,2,
     &     3,1,2,               !even
     &     3,2,1/,
     &     ifact/1,1,2,6/
***   SYMMETRY BETWEEN FIRST AND SECOND FAMILY, C CONJUGATION **********
      INTEGER ifamexchange12(-16:16)
      DATA    ifamexchange12/
     &     -16,-15,-12,-11,-14,-13,-10,-9,-8,-7,-6,-5,-2,-1,-4,-3,0,
     &     3,4,1,2,5,6,7,8,9,10,13,14,11,12,15,16/
****************************CUTS *************************************
      INTEGER ipasscuts
      EXTERNAL ipasscuts
**********************RANDOM NUMBERS *********************************
      REAL*8 ran2
      INTEGER idum
*************************UTILITY *************************************
      INTEGER i,j,l,k,i0,i1,i2,i3
      INTEGER i1_cteq,i2_cteq
***********************************************************************
*************************EXECUTABLE CODE *****************************
***********************************************************************
c Ezio 25 Apr 04
      e_cm_min=sqrt(shatmin)   
      e_cm_max=sqrt(s)
      spm1=3.d3
      call PHSP_INI2(e_cm_max,e_cm_min,spm1,
     &                           alfa1,
     &               xf1_min,xf1_max,xf2_min,xf2_max)
      IF(x(1).LE.alfa1.AND.alfa1.GT.0.d0)THEN
        vegas_x=x(1)/alfa1
        e_cm=(xf1_max-xf1_min)*vegas_x+xf1_min
        rjacz=(xf1_max-xf1_min)*2.d0*e_cm/alfa1
      ELSE
        vegas_x=(x(1)-alfa1)/(1.d0-alfa1)
        e_cm=(xf2_max-xf2_min)*vegas_x+xf2_min
        rjacz=(xf2_max-xf2_min)*2.d0*e_cm/(1.d0-alfa1)
      ENDIF  
      z=e_cm*e_cm/s
      rjacz=rjacz/s                               ! Jacobian of dz
      IF(z.LE.0.d0.OR.z.GT.1.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF
      ys=-2.d0*log(sqrt(z))*x(2)+log(sqrt(z))
      rjacys=-2.d0*log(sqrt(z))                 ! Jacobian of dy
c Ezio-end 25 Apr 04

      fxn=1.d0

      shat=z*s
      IF(shat.LE.shatmin)THEN
        fxn=0.d0
        RETURN
      ENDIF
      ecm=dsqrt(shat)
      fluxhat=flux/z

* SOME USEFUL QUANTITIES FOR BOOSTS FROM HARD SCATTERING REST FRAME 
*     TO COLLIDER FRAME
      b1=sqrt(z)*exp(-ys)
      b2=sqrt(z)*exp(ys)
      IF(b1.LE.1.d-5 .OR .b2.LE.1.d-5 .OR. b1.GE.1.d0
     &     .OR. b2.GE.1.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF
*     boost variables
      IF((b1+b2).LE.0.d0 .OR. (b1*b2).LE.0.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF
      bcm=(b1-b2)/(b1+b2)
      gcm=(b1+b2)/(2.d0*sqrt(b1*b2))

*     MASSES
      DO i=1,8
        xm(i)=rmass(idp(i))
        xmsq(i)=rmass2(idp(i))
      ENDDO

*     EXTRACT INITIAL STATE PARTICLES
      idin0(1)=idp(iorder(1,iphs_ind))
      idin0(2)=idp(iorder(2,iphs_ind))
      IF(idin0(1).EQ.idin0(2))THEN
        nidenticalinitial=2
      ELSE
        nidenticalinitial=1
      ENDIF

      xmasq=xmsq(iorder(1,iphs_ind))
      xmbsq=xmsq(iorder(2,iphs_ind))

      IF(iphs_ind.le.5)THEN
        CALL phsp1_1_4_multi5_c(x(3),shat,
     &       rm1(iphs_ind),gam1(iphs_ind),spm1lo(iphs_ind),
     &       spm1hi(iphs_ind),rm11a(iphs_ind),gam11a(iphs_ind),
     &       spm11alo(iphs_ind),spm11ahi(iphs_ind),
     &       rm11b(iphs_ind),gam11b(iphs_ind),spm11blo(iphs_ind),
     &       spm11bhi(iphs_ind),
     &       rm12a(iphs_ind),gam12a(iphs_ind),
     &       spm12alo(iphs_ind),spm12ahi(iphs_ind),
     &       rm12b(iphs_ind),gam12b(iphs_ind),spm12blo(iphs_ind),
     &       spm12bhi(iphs_ind),
     &       rmta(iphs_ind),expa(iphs_ind),
     &       spta,rmtb(iphs_ind),expb(iphs_ind),sptb,
     &       pt5min,pt6min,
     &       xmasq,xmbsq,
     &       xm,xmsq,iorder(3,iphs_ind),
     &       p,xjac)
      ELSE IF(iphs_ind.ge.6.and.iphs_ind.le.11)THEN
        CALL phsp2_4_multi5(x(3),shat,
     &       rm1(iphs_ind),gam1(iphs_ind),spm1lo(iphs_ind),
     &       spm1hi(iphs_ind),rm11a(iphs_ind),gam11a(iphs_ind),
     &       spm11alo(iphs_ind),spm11ahi(iphs_ind),
     &       rm11b(iphs_ind),gam11b(iphs_ind),spm11blo(iphs_ind),
     &       spm11bhi(iphs_ind),
     &       rm12a(iphs_ind),gam12a(iphs_ind),
     &       spm12alo(iphs_ind),spm12ahi(iphs_ind),
     &       rm12b(iphs_ind),gam12b(iphs_ind),spm12blo(iphs_ind),
     &       spm12bhi(iphs_ind),
     &       rm2a(iphs_ind),gam2a(iphs_ind),
     &       spm2alo(iphs_ind),spm2ahi(iphs_ind),rm2b(iphs_ind),
     &       gam2b(iphs_ind),spm2blo(iphs_ind),spm2bhi(iphs_ind),
     &       xm,xmsq,iorder(3,iphs_ind),
     &       p,xjac)
      ELSE IF(iphs_ind.ge.12.and.iphs_ind.le.13)THEN
        CALL phsp1_1_31_multi_c(x(3),shat,
     &       rm1(iphs_ind),gam1(iphs_ind),spm1lo(iphs_ind),
     &       spm1hi(iphs_ind),rm11(iphs_ind),gam11(iphs_ind),
     &       spm11lo(iphs_ind),spm11hi(iphs_ind),rm111(iphs_ind),
     &       gam111(iphs_ind),
     &       spm111lo(iphs_ind),
     &       spm111hi(iphs_ind),rmta(iphs_ind),expa(iphs_ind),
     &       spta,rmtb(iphs_ind),expb(iphs_ind),sptb,
     &       pt5min,pt6min,
     &       xmasq,xmbsq,
     &       xm,xmsq,iorder(3,iphs_ind),
     &       p,xjac)
      ELSE IF(iphs_ind.ge.14.and.iphs_ind.le.16)THEN
        CALL phsp1_2_3_multi5_c(x(3),shat,
     &       rm1(iphs_ind),gam1(iphs_ind),spm1lo(iphs_ind),
     &       spm1hi(iphs_ind),rm11(iphs_ind),gam11(iphs_ind),
     &       spm11lo(iphs_ind),spm11hi(iphs_ind),rm2a(iphs_ind),
     &       gam2a(iphs_ind),spm2alo(iphs_ind),spm2ahi(iphs_ind),
     &       rm2b(iphs_ind),gam2b(iphs_ind),spm2blo(iphs_ind),
     &       spm2bhi(iphs_ind),
     &       rmta(iphs_ind),expa(iphs_ind),spta,
     &       pt6min,
     &       idin0(1),idin0(2),idp(iorder(8,iphs_ind)),
     &       xm,xmsq,iorder(3,iphs_ind),
     &       p,xjac)
      ELSE 
        CALL phsp3_3_multi5(x(3),shat,
     &       rm1(iphs_ind),gam1(iphs_ind),spm1lo(iphs_ind),
     &       spm1hi(iphs_ind),rm11a(iphs_ind),gam11a(iphs_ind),
     &       spm11alo(iphs_ind),spm11ahi(iphs_ind),
     &       rm11b(iphs_ind),gam11b(iphs_ind),spm11blo(iphs_ind),
     &       spm11bhi(iphs_ind),
     &       rm2(iphs_ind),gam2(iphs_ind),
     &       spm2lo(iphs_ind),spm2hi(iphs_ind),rm21a(iphs_ind),
     &       gam21a(iphs_ind),spm21alo(iphs_ind),
     &       spm21ahi(iphs_ind),rm21b(iphs_ind),gam21b(iphs_ind),
     &       spm21blo(iphs_ind),spm21bhi(iphs_ind),
     &       xm,xmsq,iorder(3,iphs_ind),
     &       p,xjac)
      ENDIF

      IF(xjac.LE.0.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF

* INCOMING MOMENTA IN HARD SCATTERING CENTER OF MASS FRAME
*  THEY ARE IN A FIXED POSITION IN THE ARRAY p EVEN WHEN IDENTICAL
*  PARTICLES ARE PRESENT
      app=((shat-xmasq-xmbsq)**2
     &     -4.d0*xmasq*xmbsq)/(4.d0*shat)
      IF(app.LE.0.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF
      pmod=sqrt(app)
      p(0,iorder(1,iphs_ind))=sqrt(pmod*pmod+xmasq)
      p(1,iorder(1,iphs_ind))=0.d0
      p(2,iorder(1,iphs_ind))=0.d0
      p(3,iorder(1,iphs_ind))=pmod
      p(0,iorder(2,iphs_ind))=sqrt(pmod*pmod+xmbsq)
      p(1,iorder(2,iphs_ind))=0.d0
      p(2,iorder(2,iphs_ind))=0.d0
      p(3,iorder(2,iphs_ind))=-pmod

* BOOST TO COLLIDER FRAME
      DO i=1,8
        CALL ZBOOST(gcm,bcm,p(0,i),pcoll(0,i))
      ENDDO

* CUTS: EXPECTS pcoll((0:3,8) in one-to-one correspondence with idp and 
*     idp_inout
      

      ipass1=ipasscuts(pcoll,
     &     e_min_lep,pt_min_lep,eta_max_lep,ptmiss_min,
     &     e_min_j,pt_min_j,eta_max_j,
     &     eta_def_jf_min,eta_def_jb_max,eta_def_jc_max,
     &     pt_min_jcjc,rm_min_jj,rm_min_jlep,
     &     rm_min_jcjc,rm_max_jcjc,
     &     rm_min_jfjb,eta_min_jfjb,
     &     d_ar_jj,d_ar_jlep,
     &     thetamin_jj,thetamin_jlep,
     &     i_e_min_lep,i_pt_min_lep,i_eta_max_lep,i_ptmiss_min,
     &     i_e_min_j,i_pt_min_j,i_eta_max_j,i_eta_jf_jb_jc,
     &     i_pt_min_jcjc,i_rm_min_jj,i_rm_min_jlep,
     &     i_rm_min_jcjc,i_rm_max_jcjc,
     &     i_rm_min_jfjb,i_eta_min_jfjb,
     &     i_d_ar_jj,i_d_ar_jlep,
     &     i_thetamin_jj,i_thetamin_jlep,
     &     i_usercuts, 0)

      IF (ipass1.eq.0)then     
        fxn=0.d0
        RETURN
      ENDIF


      if (ionesh.eq.1.and.iextracuts.eq.1) then
        ipass2=ipasscuts(pcoll,     
     &      e_min_lepos,pt_min_lepos,eta_max_lepos,ptmiss_minos,
     &      e_min_jos,pt_min_jos,eta_max_jos,
     &      eta_def_jf_minos,eta_def_jb_maxos,eta_def_jc_maxos,
     &      pt_min_jcjcos,rm_min_jjos,rm_min_jlepos,
     &      rm_min_jcjcos,rm_max_jcjcos,
     &      rm_min_jfjbos,eta_min_jfjbos,
     &      d_ar_jjos,d_ar_jlepos,
     &      thetamin_jjos,thetamin_jlepos,
     &      i_e_min_lepos,i_pt_min_lepos,i_eta_max_lepos,i_ptmiss_minos,
     &      i_e_min_jos,i_pt_min_jos,i_eta_max_jos,i_eta_jf_jb_jcos,
     &      i_pt_min_jcjcos,i_rm_min_jjos,i_rm_min_jlepos,
     &      i_rm_min_jcjcos,i_rm_max_jcjcos,
     &      i_rm_min_jfjbos,i_eta_min_jfjbos,
     &      i_d_ar_jjos,i_d_ar_jlepos,
     &      i_thetamin_jjos,i_thetamin_jlepos,
     &      0,i_usercutsos)

        IF (ipass2.eq.0)then 
          fxn=0.d0
          RETURN
        ENDIF
      endif

* CALL DISTRIBUTION FUNCTIONS
*  FACTORIZATION SCALE FOR PDF'S: 
*     Q**2= rmw**2+average(pt**2) 
      Q=rmw**2
      DO i=1,8
        IF(idp_inout(i).GT.0)THEN
          Q=Q+(p(1,i)**2+p(2,i)**2)/6.d0
        ENDIF
      ENDDO
      Q=sqrt(Q)
      IF(Q.GE.10000.d0.OR.Q.LE.1.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF
*** accounting for the difference between PDG and CTEQ convention
      DO i=1,2
        IF(ABS(idin0(i)).EQ.1)THEN
          idin0_cteq(i)=2*idin0(i)/ABS(idin0(i))
        ELSE IF(ABS(idin0(i)).EQ.2)THEN
          idin0_cteq(i)=1*idin0(i)/ABS(idin0(i))
        ELSE
          idin0_cteq(i)=idin0(i)
        ENDIF
      ENDDO                     !i

      IF(i_ccfam.EQ.0)THEN
        distfuntot=ctq5pdf(-idin0_cteq(1),b1,Q)*
     &       ctq5pdf(-idin0_cteq(2),b2,Q)
      ELSE                      ! sum
        i1=ifamexchange12(-idin0(1))
        i2=ifamexchange12(-idin0(2))
        IF(ABS(i1).EQ.1)THEN
          i1_cteq=2*i1/ABS(i1)
        ELSE IF(ABS(i1).EQ.2)THEN
          i1_cteq=1*i1/ABS(i1)
        ELSE
          i1_cteq=i1
        ENDIF                   !i1
        IF(ABS(i2).EQ.1)THEN
          i2_cteq=2*i2/ABS(i2)
        ELSE IF(ABS(i2).EQ.2)THEN
          i2_cteq=1*i2/ABS(i2)
        ELSE
          i2_cteq=i2
        ENDIF                   !i2

        distfun(1)=ctq5pdf(-idin0_cteq(1),b1,Q)*
     &       ctq5pdf(-idin0_cteq(2),b2,Q)
* FAMILY_1 <--> FAMILY_2
        distfun(2)=ctq5pdf(i1_cteq,b1,Q)*ctq5pdf(i2_cteq,b2,Q)
* C CONJUGATION        
        distfun(3)=ctq5pdf(idin0_cteq(1),b1,Q)*
     &       ctq5pdf(idin0_cteq(2),b2,Q)
*     FAMILY_1 <--> FAMILY_2 + C CONJUGATION 
        distfun(4)=ctq5pdf(-i1_cteq,b1,Q)*ctq5pdf(-i2_cteq,b2,Q)
*     SUM
        distfuntot=distfun(1)
        DO i=2,4
          distfuntot=distfuntot+distfun(i)
        ENDDO
      ENDIF

      IF(distfuntot.LE.0.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF
* SYMMETRY BETWEEN INCOMING PROTONS
c      IF(idin0(1).NE.idin0(2)) distfuntot=2.d0*distfuntot
*** no more symmetry between incoming protons for single run .
***  for one shot the factor 2 is accounted for in oneshot sampling

*     IF DOING NORMALIZATION RETURN
      IF(i_normalize.EQ.1)THEN
        fxn=distfuntot*rjacys*rjacz
**** numero di chiamate effettive
        ncall_eff=ncall_eff+1
        RETURN
      ENDIF
* CHECK FOR IDENTICAL FINAL STATE PARTICLES
      DO i=-16,16
        nidentical(i)=0
      ENDDO
      DO i=1,8
        IF(idp_inout(i).GT.0)THEN
          nidentical(idp(i))=nidentical(idp(i))+1
          ipos0(nidentical(idp(i)),idp(i))=i
        ENDIF
      ENDDO
* FIND MULTIPLICITIES > 1:THERE CAN BE AT MOST 3 IN 4Z PROCESSES IF 
*  ONE Z  DECAYS TO LEPTONS. 
* FIND ALSO A PARTICLE WITH MULTIPLICITY ZERO TO BE USED
*     IN REDUNDANT DO-LOOPS
      nmultiple=0    
      DO i=-16,16
        IF(nidentical(i).GT.1)THEN
          nmultiple=nmultiple+1
          i_identical(nmultiple)=i
        ENDIF
        IF(nidentical(i).EQ.0) i_multzero=i
      ENDDO
      IF(nmultiple.GT.3)THEN
        PRINT*,'nmultiple=',nmultiple,'    SOMETHING IS WRONG!'
        STOP
      ENDIF
      DO i= nmultiple+1,3
        i_identical(i)=i_multzero
      ENDDO
      symfact= ifact(nidentical(i_identical(3)))
     &     *ifact(nidentical(i_identical(2)))
     &     *ifact(nidentical(i_identical(1)))

      denfac=0.d0   
** Ezio 18/03/04
      izerojac=0
** Ezio-end 18/03/04    
  
* COMPUTE JACOBIANS, SYMMETRIZE ON IDENTICAL PARTICLES
      DO i3=1,ifact(nidentical(i_identical(3)))
        DO i2=1,ifact(nidentical(i_identical(2)))
          DO i1=1,ifact(nidentical(i_identical(1)))
* LOAD BASIC ORDERING
            DO l=1,8
              iordaux(l)=l
            ENDDO
* PERMUTE INDICES OF IDENTICAL PARTICLES
            DO l=1,nidentical(i_identical(1))
              iordtemp(index(l,i1))=ipos0(l,i_identical(1))
            ENDDO
            DO l=1,nidentical(i_identical(1))
              iordaux(ipos0(l,i_identical(1)))=iordtemp(l)
            ENDDO
            DO l=1,nidentical(i_identical(2))
              iordtemp(index(l,i2))=ipos0(l,i_identical(2))
            ENDDO
            DO l=1,nidentical(i_identical(2))
              iordaux(ipos0(l,i_identical(2)))=iordtemp(l)
            ENDDO
            DO l=1,nidentical(i_identical(3))
              iordtemp(index(l,i3))=ipos0(l,i_identical(3))
            ENDDO
            DO l=1,nidentical(i_identical(3))
              iordaux(ipos0(l,i_identical(3)))=iordtemp(l)
            ENDDO
* LOOP ON PHASE SPACES 
            DO k=1,mxnphs
              IF(ialfa(k).NE.0)THEN
* PERMUTE IORDER
                DO l=1,8
                  iorderaux(l)=iordaux(iorder(l,k))
                ENDDO
                IF(k.le.5)THEN
                  CALL phsp1_1_4_multi5_cjac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11a(k),gam11a(k),spm11alo(k),spm11ahi(k),
     &                 rm11b(k),gam11b(k),spm11blo(k),spm11bhi(k),
     &                 rm12a(k),gam12a(k),spm12alo(k),spm12ahi(k),
     &                 rm12b(k),gam12b(k),spm12blo(k),spm12bhi(k),
     &                 rmta(k),expa(k),spta,rmtb(k),expb(k),sptb,
     &                 pt5min,pt6min,
     &                 xmasq,xmbsq,
     &                 xm,xmsq,iorderaux(3),
     &                 p,xjac)
                ELSE IF(k.ge.6.and.k.le.11)THEN
                  CALL phsp2_4_multi5jac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11a(k),gam11a(k),spm11alo(k),spm11ahi(k),
     &                 rm11b(k),gam11b(k),spm11blo(k),spm11bhi(k),
     &                 rm12a(k),gam12a(k),spm12alo(k),spm12ahi(k),
     &                 rm12b(k),gam12b(k),spm12blo(k),spm12bhi(k),
     &                 rm2a(k),gam2a(k),spm2alo(k),spm2ahi(k),
     &                 rm2b(k),gam2b(k),spm2blo(k),spm2bhi(k),
     &                 xm,xmsq,iorderaux(3),
     &                 p,xjac)
                ELSE IF(k.ge.12.and.k.le.13)THEN
                  CALL phsp1_1_31_multi_cjac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11(k),gam11(k),
     &                 spm11lo(k),spm11hi(k),
     &                 rm111(k),gam111(k),
     &                 spm111lo(k),spm111hi(k),
     &                 rmta(k),expa(k),spta,rmtb(k),expb(k),sptb,
     &                 pt5min,pt6min,
     &                 xmasq,xmbsq,
     &                 xm,xmsq,iorderaux(3),
     &                 p,xjac)
                ELSE IF(k.ge.14.and.k.le.16)THEN
                  CALL phsp1_2_3_multi5_cjac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11(k),gam11(k),
     &                 spm11lo(k),spm11hi(k),
     &                 rm2a(k),gam2a(k),spm2alo(k),spm2ahi(k),
     &                 rm2b(k),gam2b(k),spm2blo(k),spm2bhi(k),
     &                 rmta(k),expa(k),spta,
     &                 pt6min,
     &                 idin0(1),idin0(2),idp(iorder(8,k)),
     &                 xm,xmsq,iorderaux(3),
     &                 p,xjac)
                ELSE
                  CALL phsp3_3_multi5jac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11a(k),gam11a(k),spm11alo(k),spm11ahi(k),
     &                 rm11b(k),gam11b(k),spm11blo(k),spm11bhi(k),
     &                 rm2(k),gam2(k),spm2lo(k),spm2hi(k),
     &                 rm21a(k),gam21a(k),spm21alo(k),spm21ahi(k),
     &                 rm21b(k),gam21b(k),spm21blo(k),spm21bhi(k),
     &                 xm,xmsq,iorderaux(3),
     &                 p,xjac)
                ENDIF

                IF(xjac.GT.0.d0)THEN
*** Ezio 21/4/04 
*                  IF(k.EQ.2 .OR. k.EQ.3 .OR. k.EQ.12 .OR. k.EQ.13
*     &              .OR. k.EQ.14 .AND. nidenticalinitial.EQ.2)THEN
                  IF(nidenticalinitial.EQ.2  .AND. 
     &            (k.EQ.2 .OR. k.EQ.3 .OR. k.EQ.12 .OR. k.EQ.13
     &              .OR. k.EQ.14) 
     &               )THEN
*** Ezio 21/4/04
                    denfac=denfac+alfa(k)/xjac/symfact/rnormal(k)
     &                   /2.d0
                  ELSE
                    denfac=denfac+alfa(k)/xjac/symfact/rnormal(k)
                  ENDIF
** Ezio 18/03/04
                ELSE
		  izerojac=1 		
** Ezio-end 18/03/04    
                ENDIF           ! ENDIF xjac.GT.0.d0
              ENDIF             ! ENDIF(ialfa(k)>NE.0)
            ENDDO               ! ENDDO k PHASE SPACES
          ENDDO                 ! ENDDO i1 PERMUTATIONS2 
        ENDDO                   ! ENDDO i2 PERMUTATIONS2 
      ENDDO                     ! ENDDO i3 PERMUTATIONS1 

* FLIP FINAL STATE MOMENTA FOR PHASE SPACES 2,3,12,13,15,16 IN ORDER 
* TO ACCOUNT FOR SYMMETRY BETWEEN INCOMING PARTICLES
      IF(nidenticalinitial.EQ.2)THEN
        DO i=1,8
          DO j=0,3
            paux(j,i)=p(j,i)
          ENDDO
        ENDDO
* FLIP
        DO i=3,8
          paux(3,iorder(i,iphs_ind))=-paux(3,iorder(i,iphs_ind))
          paux(2,iorder(i,iphs_ind))=-paux(2,iorder(i,iphs_ind))
	ENDDO
*     COMPUTE EXTRA JACOBIANS
        DO i3=1,ifact(nidentical(i_identical(3)))
          DO i2=1,ifact(nidentical(i_identical(2)))
            DO i1=1,ifact(nidentical(i_identical(1)))
* LOAD BASIC ORDERING
              DO l=1,8
                iordaux(l)=l
              ENDDO
* PERMUTE INDICES OF IDENTICAL PARTICLES
              DO l=1,nidentical(i_identical(1))
                iordtemp(index(l,i1))=ipos0(l,i_identical(1))
              ENDDO
              DO l=1,nidentical(i_identical(1))
                iordaux(ipos0(l,i_identical(1)))=iordtemp(l)
              ENDDO
              DO l=1,nidentical(i_identical(2))
                iordtemp(index(l,i2))=ipos0(l,i_identical(2))
              ENDDO
              DO l=1,nidentical(i_identical(2))
                iordaux(ipos0(l,i_identical(2)))=iordtemp(l)
              ENDDO
              DO l=1,nidentical(i_identical(3))
                iordtemp(index(l,i3))=ipos0(l,i_identical(3))
              ENDDO
              DO l=1,nidentical(i_identical(3))
                iordaux(ipos0(l,i_identical(3)))=iordtemp(l)
              ENDDO
* LOOP ON PHASE SPACES
              DO k=2,3
                IF(ialfa(k).NE.0)THEN
* PERMUTE IORDER
                  DO l=1,8
                    iorderaux(l)=iordaux(iorder(l,k))
                  ENDDO
                  CALL phsp1_1_4_multi5_cjac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11a(k),gam11a(k),spm11alo(k),spm11ahi(k),
     &                 rm11b(k),gam11b(k),spm11blo(k),spm11bhi(k),
     &                 rm12a(k),gam12a(k),spm12alo(k),spm12ahi(k),
     &                 rm12b(k),gam12b(k),spm12blo(k),spm12bhi(k),
     &                 rmta(k),expa(k),spta,rmtb(k),expb(k),sptb,
     &                 pt5min,pt6min,
     &                 xmasq,xmbsq,
     &                 xm,xmsq,iorderaux(3),
     &                 paux,xjac)
                  IF(xjac.GT.0.d0)THEN
                    denfac=denfac+alfa(k)/xjac/symfact/rnormal(k)
     &                   /2.d0
                  ENDIF         ! 
                ENDIF           ! ENDIF(ialfa(k)>NE.0)
              ENDDO             ! ENDDO k PHASE SPACES
              DO k=12,13
                IF(ialfa(k).NE.0)THEN
* PERMUTE IORDER
                  DO l=1,8
                    iorderaux(l)=iordaux(iorder(l,k))
                  ENDDO
                  CALL phsp1_1_31_multi_cjac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11(k),gam11(k),
     &                 spm11lo(k),spm11hi(k),
     &                 rm111(k),gam111(k),
     &                 spm111lo(k),spm111hi(k),
     &                 rmta(k),expa(k),spta,rmtb(k),expb(k),sptb,
     &                 pt5min,pt6min,
     &                 xmasq,xmbsq,
     &                 xm,xmsq,iorderaux(3),
     &                 paux,xjac)
                  IF(xjac.GT.0.d0)THEN
                    denfac=denfac+alfa(k)/xjac/symfact/rnormal(k)
     &                   /2.d0
                  ENDIF         ! 
                ENDIF           ! ENDIF(ialfa(k)>NE.0)
              ENDDO             ! ENDDO k PHASE SPACES
              DO k=14,14
                IF(ialfa(k).NE.0)THEN
* PERMUTE IORDER
                  DO l=1,8
                    iorderaux(l)=iordaux(iorder(l,k))
                  ENDDO
                  CALL phsp1_2_3_multi5_cjac(shat,
     &                 rm1(k),gam1(k),spm1lo(k),spm1hi(k),
     &                 rm11(k),gam11(k),
     &                 spm11lo(k),spm11hi(k),
     &                 rm2a(k),gam2a(k),spm2alo(k),spm2ahi(k),
     &                 rm2b(k),gam2b(k),spm2blo(k),spm2bhi(k),
     &                 rmta(k),expa(k),spta,
     &                 pt6min,
     &                 idin0(1),idin0(2),idp(iorder(8,k)),
     &                 xm,xmsq,iorderaux(3),
     &                 paux,xjac)
                  IF(xjac.GT.0.d0)THEN
                    denfac=denfac+alfa(k)/xjac/symfact/rnormal(k)
     &                   /2.d0
** Ezio 18/03/04
                  ELSE
		    izerojac=1 		
** Ezio-end 18/03/04    
                  ENDIF         ! 
                ENDIF           ! ENDIF(ialfa(k)>NE.0)
              ENDDO             ! ENDDO k PHASE SPACES
            ENDDO               ! ENDDO i1 PERMUTATIONS2 
          ENDDO                 ! ENDDO i2 PERMUTATIONS2 
        ENDDO                   ! ENDDO i3 PERMUTATIONS1 
      ENDIF                     ! IF(nidenticalinitial.EQ.2)
** Ezio 18/03/04
                  
      IF(izerojac.EQ.1)THEN 		
        fxn=0.d0
        RETURN
      ENDIF
** Ezio-end 18/03/04    

***elena (24/02/04)     
      IF(denfac.LE.0.d0)THEN
        fxn=0.d0
        RETURN
      ENDIF
***elenaend
      
* ROTATE WITH PROBABILITY 0.5 ALL MOMENTA BY 180 DEGREES AROUND x-AXIS
      IF (nidenticalinitial.EQ.2 .OR.
     &           (ionesh.EQ.1.AND.i_exchincoming.eq.1)) THEN
        IF(ran2(idum).GT.0.5d0)THEN
          DO i=1,8
            pcoll(3,i)=-pcoll(3,i)
            pcoll(2,i)=-pcoll(2,i)
          ENDDO
        ENDIF
      ENDIF
      
      
*     CALL AMPLITUDE: USE CM MOMENTA

      DO i=1,8
        DO mu=0,3
          p(mu,i)=p(mu,i)*idp_inout(i)
        ENDDO                   !mu
      ENDDO                     !i

      CALL amp(p,idp,igroup,symfact,amod,iordamp)

      fxn=alfa(iphs_ind)*distfuntot*amod*fluxhat*factor*rjacys*rjacz/
     &     denfac/rnormal(iphs_ind)

* REORDER MOMENTA AND IDENTITIES AS DETERMINED BY THE AMPLITUDE
      DO i=1,8
        DO mu=0,3
          paux(mu,iordamp(i))=pcoll(mu,i)
        ENDDO                   !mu
      ENDDO                     !i
      DO i=1,8
        DO mu=0,3
          pcoll(mu,i)=paux(mu,i)
        ENDDO                   !mu
      ENDDO                     !i
* IDP AND IDP_INOUT MUST BE PRESERVED
      DO i=1,8
        idp0(i)=idp(i)
        idp0_inout(i)=idp_inout(i)
      ENDDO                     !i
      DO i=1,8
        iorderaux(iordamp(i))=idp0(i)
        iordaux(iordamp(i))=idp0_inout(i)
      ENDDO                     !i
      DO i=1,8
        idp0(i)=iorderaux(i)
        idp0_inout(i)=iordaux(i)
      ENDDO                     !i
* DETERMINE THE FAMILY AND CC PARTICLE SET IF NECESSARY
      IF(i_ccfam.EQ.1)THEN
        DO i=1,4
          distfun(i)=distfun(i)/distfuntot
        ENDDO                   !i
        i=1
        distaux=distfun(1)
        zz=ran2(idum)
        DO WHILE (zz.gt.distaux)
          i=i+1
          distaux=distaux+distfun(i)
        ENDDO
* CHECK FOR ROUNDING ERRORS       
        i=min(i,4)
*     
        IF(i.EQ.2)THEN
          DO j=1,8
            IF(abs(idp0(j)).lt.6) THEN
              idp0(j)=ifamexchange12(idp0(j))
            ENDIF
          ENDDO
        ELSEIF(i.EQ.3)THEN
          DO j=1,8
            idp0(j)=-idp0(j)
          ENDDO
        ELSEIF(i.EQ.4)THEN
          DO j=1,8
            IF(abs(idp0(j)).lt.6) THEN
              idp0(j)=-ifamexchange12(idp0(j))
            ELSE
              idp0(j)=-idp0(j)
            ENDIF
          ENDDO
        ENDIF
* CHANGE FOR PARITY IF CC EXCHANGE (amplitude must remain the same)
        ichargeconj=0
        IF(i.EQ.3.OR.i.EQ.4)THEN
          ichargeconj=1
          DO j=1,8
            DO k=1,3
              pcoll(k,j)=-pcoll(k,j)
            ENDDO
          ENDDO
        ENDIF                        

      ENDIF                     ! i_ccfam.EQ.1     

      IF(iflat.EQ.1)THEN
* FIND MAXIMUM WEIGHT
*6
c        IF(it.EQ.(itmx-1) .AND. init.GE.1)THEN
c          rmaxfxn=max(rmaxfxn,fxn*wgt)
c        ENDIF
c        IF(it.EQ.itmx .AND. init.GE.1)THEN
c          rmaxfxn_2=max(rmaxfxn_2,fxn*wgt)
c        ENDIF

        rmaxfxnnew=max(rmaxfxnnew,fxn*wgt)
        
*6end
      ENDIF
      
      IF((iflat.EQ.1 .OR. ionesh.EQ.1)
*6
c     &     .AND. it.EQ.itmx.AND.init.GE.1)THEN
     &     .AND.init.GE.1)THEN
*6end
        IF(fxn*wgt.GT.rmaxfxn*scalemax)THEN
          novermax=novermax+1
        ENDIF
        ry=scalemax*rmaxfxn*ran2(idum)
        IF(ry.LE.fxn*wgt)THEN   ! EVENT ACCEPTED
*6
c          NEVHEP=NEVHEP+1
c          nevent=NEVHEP
          nevent=nevent+1
*6end
* STORE INFORMATION IN LESHOUCHES-PYTHIA FORMAT
*  PYTHIA EXPECTS INCOMING PARTICLES IN THE FIRST TWO POSITIONS
          i_outgoing=3
          DO i=1,8
            IF(idp0_inout(i).EQ.-1)THEN
	      IF(pcoll(3,i).GT.0.d0)THEN
                index_pythia(i)=1
	      ELSE
	        index_pythia(i)=2
	      ENDIF
            ELSE
              index_pythia(i)=i_outgoing
              i_outgoing=i_outgoing+1
            ENDIF
          ENDDO
          icolorline=500
          DO i=1,8
            IDUP(index_pythia(i))=idp0(i)*idp0_inout(i)
            ISTUP(index_pythia(i))=idp0_inout(i)
            DO j=1,3
              PUP(j,index_pythia(i))=pcoll(j,i)
            ENDDO
            PUP(4,index_pythia(i))=pcoll(0,i)
            PUP(5,index_pythia(i))=xm(i)
            IF(abs(idp0(i)).le.5)THEN ! quark or antiquark
              i_odd=mod(i,2)
              IF(i_odd.EQ.1)THEN ! a quark if outgoing
                icolorline=icolorline+1
                IF(idp0_inout(i).EQ.1)THEN
                  ICOLUP(1,index_pythia(i))=icolorline
                  ICOLUP(2,index_pythia(i))=0
                ELSE
                  ICOLUP(1,index_pythia(i))=0
                  ICOLUP(2,index_pythia(i))=icolorline
                ENDIF
              ELSE              ! an antiquark if outgoing
                IF(idp0_inout(i).EQ.1)THEN
                  ICOLUP(1,index_pythia(i))=0
                  ICOLUP(2,index_pythia(i))=icolorline
                ELSE
                  ICOLUP(1,index_pythia(i))=icolorline
                  ICOLUP(2,index_pythia(i))=0
                ENDIF
              ENDIF
            ELSE                ! lepton
              ICOLUP(1,index_pythia(i))=0
              ICOLUP(2,index_pythia(i))=0
            ENDIF  
          ENDDO

          IF (ichargeconj.eq.1) THEN
            DO i=1,8
              iaux=ICOLUP(1,i)
              ICOLUP(1,i)=ICOLUP(2,i)
              ICOLUP(2,i)=iaux
            ENDDO
          ENDIF
          SCALUP=Q
          AQEDUP=1.d0/alfainv
          AQCDUP=-1.d0


* CALL PS PROGRAM
          IF(ihadronize.EQ.1)THEN
* COMPLETE LESHOUCHES COMMON
            NUP=8
            IDPRUP=661
            XWGTUP=1.d0

            DO i=1,2
c incoming particles have no mother
              MOTHUP(1,i)=0
              MOTHUP(2,i)=0
            ENDDO
            DO i=3,NUP
              MOTHUP(1,i)=1
              MOTHUP(2,i)=2
            ENDDO
            DO i=1,NUP
              SPINUP(i)=9.d0
              VTIMUP(i)=0.d0
            ENDDO

            CALL PYEVNT
* WRITE OUTPUT OF PS PROGRAM
*  HERE EVENTUALLY CALL A USER PROVIDED ROUTINE FOR WRITING RESULTS,
*  OR SIMPLY USE PYLIST BELOW FOR IPRDEB (GIVEN IN INPUT) EVENTS.
            IF (NEVENT.LE.IPRDEB) CALL PYLIST(2)
          ENDIF  !ihadronize

*  WRITE LESHOUCHES EVENT: UNIT=23 is phamom.dat
          IF(iwrite_event.EQ.1)THEN
            WRITE(23,99999)(IDUP(i),i=1,8)
            WRITE(23,99998)(ISTUP(i),i=1,8)
            DO i=1,8
              WRITE(23,99997)(PUP(j,i),j=1,4)
            ENDDO
            WRITE(23,99996)((ICOLUP(j,i),j=1,2),i=1,8)
	    WRITE(23,99995)SCALUP,AQEDUP,AQCDUP
          ENDIF
        ENDIF                   ! ENDIF EVENT ACCEPTED
      ENDIF                     ! ENDIF iflat.EQ.1 .OR. ioneshot.EQ.1
      
****  numero di chiamate effettive
      ncall_eff=ncall_eff+1



99999 FORMAT('IDUP  ',8I4)
99998 FORMAT('ISTUP ',8I4)
99997 FORMAT(4E17.9)
99996 FORMAT('ICOLUP ',16I4)
99995 FORMAT('SCALUP ',E17.9,' AQEDUP ',E17.9,' AQCDUP ',E17.9)  


      RETURN
      END



      SUBROUTINE ZBOOST(gcm,bcm,q1,q2)
      IMPLICIT NONE
      REAL*8 gcm,bcm,q1(0:3),q2(0:3)
      q2(0)=gcm*(q1(0)+bcm*q1(3))
      q2(1)=q1(1)
      q2(2)=q1(2)
      q2(3)=q1(3)/gcm+bcm*q2(0)
      RETURN
      END


