************************************************************************
*                                                                      *
*                              PHASE                                   *
*                                                                      *
*                PHact Adaptive Six fermion Event generator            *
*                                                                      *
*    a Monte Carlo program for six-fermion final state processes       *
*                           at the LHC                                 *
*                                                                      *
*                   based on PHACT matrix elements                     *
*                               and                                    *
*                  adaptive+multichannel integration                   *
*                                                                      *
*                                                                      *
*     Authors: Elena Accomando, Alessandro Ballestrero, Ezio Maina     *
*                                                                      *
*                             version 1.0                              *
*                                                                      *
************************************************************************
*                                                                      *
* This program, its steering file, explanations and examples,          *
* can be found with a link to                                          *
*                                                                      *
*                 http://www.to.infn.it/~ballestr/phase                *
*                                                                      *
************************************************************************

      Program PHASE


      IMPLICIT REAL*8 (a-b,d-h,o-z)
      IMPLICIT COMPLEX*16 (c)

      INCLUDE 'common.h'
*sandro 27/7
c      COMMON/collenergy/ecoll
c      COMMON/fxn_main/s,flux,factor
      COMMON/fxn_main/flux,factor
*sandro 27/7 end

C for the reading system
      CHARACTER*80 pluto
      COMMON/abread/pluto
C How many Pythia event get printed
      COMMON/HADOUTPUT/IPRDEB
      DATA IPRDEB/5/
*ONESHOT 
      COMMON/phaones/ionesh

      DATA pb_conv/0.38937966d9/

**Ezio Per SGE
**      PRINT*,  '  name of the input file ?'
**      READ (*,'(a)') pluto       ! name of the file
      pluto='r.in'
**Ezio-end Per SGE
      PRINT*, '                          INPUT FROM FILE '//pluto

      CALL readinput
	
      IF(ihadronize.EQ.1)THEN
C...Initialize with external process.
        CALL PYINIT('USER',' ',' ',0D0)
      ENDIF

c      Iset=1                        ! MS-bar scheme
c      Iset=8                        ! improved MS-bar scheme 
c      Iset=3                        ! LO scheme

      Iset=3
      CALL SetCtq5(Iset)


      CALL coupling


      s=ecoll*ecoll
      flux=0.5d0/s              ! flux factor
      eq=4.d0*pi/alfainv        ! e**2
      factor=eq**6*pb_conv      ! overall coupling + conversion in pb



* Routine Vegas parameter:

      ndim=15

* Integration limits:
      DO i=1,ndim
        region(i)=0.d0
        region(ndim+i)=1.d0
      ENDDO !i

*sandro 25/07
c      CALL proc  ! proc  determines the variables for every phase space
                 ! that can be used and the variables for the process
                 ! at hand
                 ! If ioneshot=1 the latter are read from phavegas.dat
                 !  and only the former are determined in proc

c      if (ionesh.eq.0) then

      if (ionesh.eq.0) then

      CALL proc  ! proc  determines the variables for every phase space
                 ! that can be used and the variables for the process
                 ! at hand
                 ! If ioneshot=1 the latter are read from phavegas.dat
                 !  and only the former are determined in proc
*sandro 25/07 end         
        CALL extrema
            
        CALL integration

      else
        
        CALL oneshot    ! the call to extrema 
*sandro 25/07 
                        ! and to proc   
*sandro 25/07 end       
                        ! is in oneshot,
                        !  once the process has been chosen

      endif

      STOP
      END
      

       









