************************************************************************
*                        SUBROUTINE READINPUT                          *
*                                                                      *
*                                                                      *
*     Purpose:  reading input_file                                     *
*     Call to subroutines in wread.f                                   *
*                                                                      *
************************************************************************

      SUBROUTINE readinput

      IMPLICIT REAL*8 (a-b,d-h,o-z)
      IMPLICIT DOUBLE COMPLEX (c)

      INCLUDE 'common.h'
      INCLUDE 'common_cut.h'
*sandro 27/07
c      COMMON/collenergy/ecoll
*sandro 27/07 end
*sandro 25/07
c      COMMON/process/iproc(8)
      INCLUDE 'common_subproc.h'
*sandro 25/07 end

*     INTEGRATION COMMONS
      COMMON/iinteg_readinput/ncall_therm,itmx_therm,ncall,itmx
      COMMON/rinteg_readinput/acc_therm,acc

      COMMON/phaones/ionesh

      COMMON /pharand/ idum

      CALL iread('idum',idum,1)   ! idum=initialization random number seed
                                !  must be a large negative number

      CALL iread('ionesh',ionesh,1) 
                     ! 0= normal run of one process   
                     ! 1= one shot generation of all indicated processes
      
      CALL rread('ecoll',ecoll,1) ! collider energy
      CALL rread('rmh',rmh,1)   ! Higgs mass (GeV)

      CALL iread('i_ccfam',i_ccfam,1)           ! family+CC conjugate
       
      if (ionesh.eq.0) then

        CALL iread('iproc',iproc,8) ! process
*     READ INPUT FOR THE INTEGRATION
        CALL rread('acc_therm',acc_therm,1) ! thermalization accuracy
        CALL iread('ncall_therm',ncall_therm,1)
                                ! thermalization calls per iteration
        CALL iread('itmx_therm',itmx_therm,1) !thermalization iterations
        CALL rread('acc',acc,1) ! integration accuracy
        CALL iread('ncall',ncall,1) ! integration calls per iteration
        CALL iread('itmx',itmx,1) ! integration iterations 

*     READ INPUT FOR FLAT EVENT GENERATION
        CALL iread('iflat',iflat,1) ! yes/no flat event generation
        IF(iflat.EQ.1)THEN

*sandro 2/4/05
c          CALL rread('scalemax0',scalemax0,1) 
c                                !scale factor for the maximum
c          scalemax=scalemax0
          scalemax=1.1
*sandro 2/4/05end

c          CALL iread('istorvegas',istorvegas,1)
                                ! yes/no VEGAS data stored
          istorvegas=1

c          CALL iread('iwrite_event',iwrite_event,1)
                  ! yes/no momenta of flat events written in .dat files

          iwrite_event=0

        ENDIF   !iflat

      elseif (ionesh.eq.1) then

*     scale factor for generation

        CALL rread('scalemax',scalemax,1) 
                            !scale factor for the maximum

        CALL iread ('nunwevts',nunwevts,1)	 
               !  number of unweighted events to be produced

        CALL iread('iwrite_event',iwrite_event,1)
                  ! yes/no momenta of flat events written in .dat files

        CALL iread('ihadronize',ihadronize,1) 
                                ! yes/no call to hadronization

        CALL iread('i_exchincoming',i_exchincoming,1)  

        CALL iread('i_emutau',i_emutau,1)  
           
      endif

*     READ INPUT FOR CUTS
      CALL iread('i_e_min_lep',i_e_min_lep,1) ! lepton energy lower cuts 
                                !     (GeV)
      IF(i_e_min_lep.EQ.1) CALL rread('e_min_lep',e_min_lep,1) 
      CALL iread('i_pt_min_lep',i_pt_min_lep,1) 
                                ! lepton pt lower cuts (GeV)
      IF(i_pt_min_lep.EQ.1) CALL rread('pt_min_lep',pt_min_lep,1)
      CALL iread('i_eta_max_lep',i_eta_max_lep,1) 
                                !lepton rapidity upper cuts (absolute value)
      IF(i_eta_max_lep.EQ.1) CALL rread('eta_max_lep',eta_max_lep,1)
      CALL iread('i_ptmiss_min',i_ptmiss_min,1) 
                                ! missing pt lower cuts (GeV)
      IF(i_ptmiss_min.EQ.1) CALL rread('ptmiss_min',ptmiss_min,1)
      CALL iread('i_e_min_j',i_e_min_j,1) ! jet energy lower cuts (GeV)
      IF(i_e_min_j.EQ.1) CALL rread('e_min_j',e_min_j,1)
      CALL iread('i_pt_min_j',i_pt_min_j,1) ! jet pt lower cuts (GeV)
      IF(i_pt_min_j.EQ.1) CALL rread('pt_min_j',pt_min_j,1)
      CALL iread('i_eta_max_j',i_eta_max_j,1) 
                                ! jet rapidity upper cuts  (absolute value)
      IF(i_eta_max_j.EQ.1) CALL rread('eta_max_j',eta_max_j,1)

      CALL iread('i_eta_jf_jb_jc',i_eta_jf_jb_jc,1)
                                ! rapidity of forward, backward and central jets
      IF(i_eta_jf_jb_jc.EQ.1) THEN
        CALL rread('eta_def_jf_min',eta_def_jf_min,1) 
                                ! min rapidity for a jet to be called forward
        CALL rread('eta_def_jb_max',eta_def_jb_max,1) 
                                ! max rapidity for a jet to be called backward
        CALL rread('eta_def_jc_max',eta_def_jc_max,1) 
                                ! max rapidity for a jet to be called central (absolute value)
      ENDIF ! (i_eta_jf_jb_jc.EQ.1)

      CALL iread('i_pt_min_jcjc',i_pt_min_jcjc,1) ! pt lower cuts 
                                ! on two centraljets (GeV)
      IF(i_pt_min_jcjc.EQ.1) 
     &     CALL rread('pt_min_jcjc',pt_min_jcjc,1)
      CALL iread('i_rm_min_jj',i_rm_min_jj,1) 
                                ! minimum invariant mass  between jets (GeV)
      IF(i_rm_min_jj.EQ.1) CALL rread('rm_min_jj',rm_min_jj,1)
      CALL iread('i_rm_min_jlep',i_rm_min_jlep,1) 
                                ! minimum invariant mass between jets and lepton (GeV)
      IF(i_rm_min_jlep.EQ.1) CALL rread('rm_min_jlep',rm_min_jlep,1)
      CALL iread('i_rm_min_jcjc',i_rm_min_jcjc,1)
                                ! minimum invariant mass between central jets (GeV)
      IF(i_rm_min_jcjc.EQ.1) 
     &     CALL rread('rm_min_jcjc',rm_min_jcjc,1) 
      CALL iread('i_rm_max_jcjc',i_rm_max_jcjc,1) 
                                ! maximum invariant mass between central jets (GeV)
      IF(i_rm_max_jcjc.EQ.1) 
     &     CALL rread('rm_max_jcjc',rm_max_jcjc,1) 
      CALL iread('i_rm_min_jfjb',i_rm_min_jfjb,1) 
                                ! minimum invariant mass between forward and backward jet
      IF(i_rm_min_jfjb.EQ.1) 
     &     CALL rread('rm_min_jfjb',rm_min_jfjb,1) 
      CALL iread('i_eta_min_jfjb',i_eta_min_jfjb,1) 
                                ! minimum rapidity difference between forward and backward jet
      IF(i_eta_min_jfjb.EQ.1) 
     &     CALL rread('eta_min_jfjb',eta_min_jfjb,1)
      CALL iread('i_d_ar_jj',i_d_ar_jj,1) 
                                ! minimum delta_R separation between jets
      IF(i_d_ar_jj.EQ.1) CALL rread('d_ar_jj',d_ar_jj,1)
      CALL iread('i_d_ar_jlep',i_d_ar_jlep,1)
                                ! minimum delta_R separation between jets and
				! lepton
      IF(i_d_ar_jlep.EQ.1) CALL rread('d_ar_jlep',d_ar_jlep,1)
      CALL iread('i_thetamin_jj',i_thetamin_jj,1) 
                                ! minimum angle separation between jets (cosine)
      IF(i_thetamin_jj.EQ.1) 
     &     CALL rread('thetamin_jj',thetamin_jj,1)
      CALL iread('i_thetamin_jlep',i_thetamin_jlep,1) 
                                ! minimum angle separation between jets and lepton (cosine)
      IF(i_thetamin_jlep.EQ.1) 
     &     CALL rread('thetamin_jlep',thetamin_jlep,1)
      CALL iread('i_usercuts',i_usercuts,1) ! yes/no (1/0) additional
                                ! user-defined cuts

      if (ionesh.eq.1) then

*     eventual more restrictive cuts

        CALL iread('iextracuts',iextracuts,1)

        if (iextracuts. eq.1) then

          CALL iread('i_e_min_lepos',i_e_min_lepos,1) 
                                ! lepton energy lower cuts (GeV)
          IF(i_e_min_lepos.EQ.1) CALL rread('e_min_lepos',e_min_lepos,1) 
          CALL iread('i_pt_min_lepos',i_pt_min_lepos,1) 
                                ! lepton pt lower cuts (GeV)
          IF(i_pt_min_lepos.EQ.1) 
     &         CALL rread('pt_min_lepos',pt_min_lepos,1)
          CALL iread('i_eta_max_lepos',i_eta_max_lepos,1) 
                                !lepton rapidity upper cuts (absolute value)
          IF(i_eta_max_lepos.EQ.1) 
     &         CALL rread('eta_max_lepos',eta_max_lepos,1)
          CALL iread('i_ptmiss_minos',i_ptmiss_minos,1) 
                                ! missing pt lower cuts (GeV)
          IF(i_ptmiss_minos.EQ.1) 
     &         CALL rread('ptmiss_minos',ptmiss_minos,1)
          CALL iread('i_e_min_jos',i_e_min_jos,1) 
                                ! jet energy lower cuts (GeV)
          IF(i_e_min_jos.EQ.1) CALL rread('e_min_jos',e_min_jos,1)
          CALL iread('i_pt_min_jos',i_pt_min_jos,1) 
                                !jet pt lower cuts (GeV)
          IF(i_pt_min_jos.EQ.1) CALL rread('pt_min_jos',pt_min_jos,1)
          CALL iread('i_eta_max_jos',i_eta_max_jos,1) 
                             ! jet rapidity upper cuts  (absolute value)
          IF(i_eta_max_jos.EQ.1) CALL rread('eta_max_jos',eta_max_jos,1)


          CALL iread('i_eta_jf_jb_jcos',i_eta_jf_jb_jcos,1)
                             ! rapidity of forward, backward and central jets
          IF(i_eta_jf_jb_jcos.EQ.1) THEN
            CALL rread('eta_def_jf_minos',eta_def_jf_minos,1) 
                          ! min rapidity for a jet to be called forward
            CALL rread('eta_def_jb_maxos',eta_def_jb_maxos,1) 
                          ! max rapidity for a jet to be called backward
            CALL rread('eta_def_jc_maxos',eta_def_jc_maxos,1)
                ! max rapidity for a jet to be called central (absolute value)
          ENDIF   !  (i_eta_jf_jb_jcos.EQ.1)

          CALL iread('i_pt_min_jcjcos',i_pt_min_jcjcos,1) 
                         ! pt lower cuts  on two centraljets (GeV)
          IF(i_pt_min_jcjcos.EQ.1) 
     &         CALL rread('pt_min_jcjcos',pt_min_jcjcos,1)
          CALL iread('i_rm_min_jjos',i_rm_min_jjos,1) 
                           ! minimum invariant mass  between jets (GeV)
          IF(i_rm_min_jjos.EQ.1) CALL rread('rm_min_jjos',rm_min_jjos,1)
          CALL iread('i_rm_min_jlepos',i_rm_min_jlepos,1) 
                      ! minimum invariant mass between jets and lepton (GeV)
          IF(i_rm_min_jlepos.EQ.1) 
     &         CALL rread('rm_min_jlepos',rm_min_jlepos,1)
          CALL iread('i_rm_min_jcjcos',i_rm_min_jcjcos,1)
                     ! minimum invariant mass between central jets (GeV)
          IF(i_rm_min_jcjcos.EQ.1) 
     &         CALL rread('rm_min_jcjcos',rm_min_jcjcos,1) 
          CALL iread('i_rm_max_jcjcos',i_rm_max_jcjcos,1) 
                     ! maximum invariant mass between central jets (GeV)
          IF(i_rm_max_jcjcos.EQ.1) 
     &         CALL rread('rm_max_jcjcos',rm_max_jcjcos,1) 
          CALL iread('i_rm_min_jfjbos',i_rm_min_jfjbos,1) 
               ! minimum invariant mass between forward and backward jet
          IF(i_rm_min_jfjbos.EQ.1) 
     &         CALL rread('rm_min_jfjbos',rm_min_jfjbos,1) 
          CALL iread('i_eta_min_jfjbos',i_eta_min_jfjbos,1) 
          ! minimum rapidity difference between forward and backward jet
          IF(i_eta_min_jfjbos.EQ.1) 
     &         CALL rread('eta_min_jfjbos',eta_min_jfjbos,1)
          CALL iread('i_d_ar_jjos',i_d_ar_jjos,1) 
                    ! minimum delta_R separation between jets
          IF(i_d_ar_jjos.EQ.1) CALL rread('d_ar_jjos',d_ar_jjos,1)
          CALL iread('i_d_ar_jlepos',i_d_ar_jlepos,1)
                   ! minimum delta_R separation between jets and lepton
          IF(i_d_ar_jlepos.EQ.1) CALL rread('d_ar_jlepos',d_ar_jlepos,1)
          CALL iread('i_thetamin_jjos',i_thetamin_jjos,1) 
                   ! minimum angle separation between jets (cosine)
          IF(i_thetamin_jjos.EQ.1) 
     &         CALL rread('thetamin_jjos',thetamin_jjos,1)
          CALL iread('i_thetamin_jlepos',i_thetamin_jlepos,1) 
             ! minimum angle separation between jets and lepton (cosine)
          IF(i_thetamin_jlepos.EQ.1) 
     &         CALL rread('thetamin_jlepos',thetamin_jlepos,1)
          CALL iread('i_usercutsos',i_usercutsos,1) 
                   ! yes/no (1/0) additional  user-defined cuts
        endif

c the number of files to consider and their names are read in oneshot

      endif

      RETURN
      END







